this.name        = "customshieldsfuelleaks"; 
this.author      = "CommonSenseOTB"; 
this.copyright   = "Copyright Sept. 24, 2012 by CommonSenseOTB, licensed under Creative Commons: attribution, non-commercial, sharealike with clauses - see readme.txt";
this.description = "Script For Fuel Leaks"; 
this.version     = "0.83";

this.shipSpawned = function()
   {
   if(this.ship && this.ship.isValid && this.ship.target && this.ship.target.isValid)
      {
	  this.customshieldsframetime = 0.0;
	  this.customshieldsframetimelimit = this.ship.target.fuel;
	  this.ship.velocity = this.ship.velocity.add(this.ship.vectorForward.multiply(10 + (this.customshieldsframetimelimit * 3)));
	  this.csfl = addFrameCallback(this.customshieldsfuelleaks.bind(this));//----------
      return;
	  }
   else
      {
	  this.ship.remove();
	  return;
	  }
   }

this.shipTakingDamage = function()
   {
   this.ship.energy = this.ship.maxEnergy;//restore energy
   if(this.customshieldsframetimelimit > (this.customshieldsframetime + 1.0))
      {
	  this.customshieldsframetimelimit = (this.customshieldsframetime + 1.0);//1 second left to exist, collision dissipates vapor cloud
	  }
   }   
   
this.customshieldsfuelleaks = function(delta)
   {
   if(this.ship && this.ship.isValid && this.ship.target && this.ship.target.isValid)
      {
	  this.customshieldsframetime += delta;
	  this.customshieldsfuelscooperpossibilities = system.filteredEntities(this, function (entity){return ((entity.fuel < 7.0) && (entity.equipmentStatus("EQ_FUEL_SCOOPS") === "EQUIPMENT_OK") && (entity !== this.ship.target))}, this.ship, 25);//must have space for fuel, working fuel scoops, and not be the one leaking the fuel to begin with 
      if(this.customshieldsfuelscooperpossibilities.length > 0)
	     {
		 if(this.customshieldsfuelscooperpossibilities[0].isPlayer)
		    {
			player.consoleMessage("Fuel vapor detected, scooping...", 4);
			if(player.ship.scoopOverride === false)//if effect is not currently active
			   {
			   player.ship.scoopOverride = true;//activate the effect
			   this.ship.spawnOne("customshieldsfuelleaksscoopoverride");//spawn marker timer for effect control
			   }
			}
		 var fuelchance = Math.ceil(Math.random() * 10);
		 if(fuelchance === 1)//1 in 10 clouds scooped results in 0.1 ly of fuel and 3 clouds spawned for every 0.1 ly of fuel a ship has results in an average max recovery of 30% of the fuel if you scoop every cloud
		    {
		    this.customshieldsfuelscooperpossibilities[0].fuel += 0.1;//contains 0.1ly fuel
			}
         removeFrameCallback(this.csfl);//----------
		 this.ship.remove();//each vapor cloud piece can be scooped only once so remove it		 
         return;
		 }	  
	  if(this.customshieldsframetime >= this.customshieldsframetimelimit)//length of time fuel vapor exists
	     {
		 removeFrameCallback(this.csfl);//----------
		 this.ship.remove();		 
         return;
		 }
      return;
      }
   else
      {
	  removeFrameCallback(this.csfl);//----------
      this.ship.remove();   
      return;
	  }
   }