this.name        = "customshieldssparksfuelleaks"; 
this.author      = "CommonSenseOTB"; 
this.copyright   = "Copyright Sept. 24, 2012 by CommonSenseOTB, licensed under Creative Commons: attribution, non-commercial, sharealike with clauses - see readme.txt";
this.description = "Script For Spawning Fuel Leaks"; 
this.version     = "0.83";

this.shipSpawned = function()
   {
   if(this.ship && this.ship.isValid && this.ship.target && this.ship.target.isValid)
      {
	  if(this.ship.target.isPlayer)
	     {
		 //message fuel leak here for player
		 //might have to use the player fuel leak command here instead to activate the built in warnings
		 player.consoleMessage("HULL BREACH! Fuel leak detected", 4);
		 this.customshieldsimpactrelativeposition = worldScripts["customshields"].customshieldsimpactrelativeposition;
		 }
      else
	     {
	     this.customshieldsimpactrelativeposition = this.ship.target.script.customshieldsimpactrelativeposition;
		 }
	  this.ship.position = this.ship.target.position.add(this.customshieldsimpactrelativeposition);	  
      this.customshieldsdirectionfuelleak = this.ship.position.subtract(this.ship.target.position).direction();
	  this.ship.orientation = this.customshieldsdirectionfuelleak.rotationTo([0, 0, 1]);
	  this.customshieldsframetime = 0.0;
	  this.customshieldsframetimefuelcounter = 1.0;
	  this.ship.spawnOne("customshieldsdamage");
	  this.ship.spawnOne("customshieldssparks");
      this.ship.spawnOne("customshieldssparks");
      this.ship.spawnOne("customshieldsblownpanels");
      this.ship.spawnOne("customshieldssparks");
      this.ship.spawnOne("customshieldssparks");
      this.ship.spawnOne("customshieldsblownpanels");
	  this.cssfl = addFrameCallback(this.customshieldssparksfuelleaks.bind(this));//----------
      return;
	  }
   else
      {
	  this.ship.remove();
	  return;
	  }
   }

this.shipTakingDamage = function()
   {
   this.ship.energy = this.ship.maxEnergy;//restore energy
   }     
   
this.customshieldssparksfuelleaks = function(delta)
   {
   if(this.ship && this.ship.isValid && this.ship.target && this.ship.target.isValid)
      {
	  this.ship.position = this.ship.target.position.add(this.customshieldsimpactrelativeposition);
	  this.customshieldsdirectionfuelleak = this.ship.position.subtract(this.ship.target.position).direction();
	  this.ship.orientation = this.customshieldsdirectionfuelleak.rotationTo([0, 0, 1]);
	  this.customshieldsframetime += delta;
	  if(this.ship.target.fuel < 0.1)//when out of fuel stop spawning it
	     {
		 removeFrameCallback(this.cssfl);//----------
		 this.ship.remove();		 
         return;
		 }
	  if(this.customshieldsframetime >= 0.1)//length of time between spawning fuel
	     {
		 this.customshieldsframetime = 0.0;//reset for next spawning
		 this.customshieldsframetimefuelcounter += 1.0;
		 if(this.customshieldsframetimefuelcounter >= 4.0)//3 clouds for every 0.1 ly of fuel
		    {
			this.customshieldsframetimefuelcounter = 1.0;
			this.ship.target.fuel -= 0.1;//remove fuel from leaking ship
			}
		 if(this.ship.target.fuel > 5.0)
		    {
			this.customshieldshighfuel = this.ship.spawnOne("customshieldsfuelleakshigh");
			this.customshieldshighfuel.orientation = this.ship.orientation;
            this.customshieldshighfuel.target = this.ship.target;
			return;
			}
         if(this.ship.target.fuel > 2.0)
		    {
			this.customshieldsmediumfuel = this.ship.spawnOne("customshieldsfuelleaksmedium");
			this.customshieldsmediumfuel.orientation = this.ship.orientation;
            this.customshieldsmediumfuel.target = this.ship.target;
			return;
			}
         if(this.ship.target.fuel > 0.1)
		    {
			this.customshieldslowfuel = this.ship.spawnOne("customshieldsfuelleakslow");
			this.customshieldslowfuel.orientation = this.ship.orientation;
            this.customshieldslowfuel.target = this.ship.target;
			return;
			}
         return;
		 }
      return;
      }
   else
      {
	  removeFrameCallback(this.cssfl);//----------
      this.ship.remove();   
      return;
	  }
   }
